package com.bea.wlevs.demo.airline.client.simulation;
import java.util.concurrent.DelayQueue;

import com.bea.wlevs.demo.airline.client.model.ModelState;


public class FlightEventQueueReader implements Runnable {

	private DelayQueue<ScheduledEvent> flightEvents_;
	private JmsEventPublisher publisher_;
	
	public FlightEventQueueReader(DelayQueue<ScheduledEvent> flightEvents) {
		flightEvents_ = flightEvents;
		publisher_ = new JmsEventPublisher();
	}
	public void run() {
		System.out.println("FlightEventQueueReader.run() on Thread:"+Thread.currentThread().getName());		
		while(true) {
			try {
				ScheduledEvent scheduledEvent = flightEvents_.take();
				long now = System.currentTimeMillis();
				ModelState event = scheduledEvent.getModelState();
				long drift = now - scheduledEvent.getScheduledTime();
				if(drift < 0) {
					//System.out.println("Event was de-queued early:"+drift);
				} else if(drift > 500){
					//System.out.println("Event was de-queued late:"+drift+" on thread:"+Thread.currentThread().getName());
				}
				/*
				System.out.println(
						"[now:"+now+
						"][event id:"+event.getID()+
						"][event start:"+scheduledEvent.getStartTime()+
						"][event scheduled:"+scheduledEvent.getScheduledTime()+
						"][ms since start:"+(now - scheduledEvent.getStartTime())+
						"][ms diff from target:"+(now - scheduledEvent.getScheduledTime())+
						"]"					
				);*/
				if(scheduledEvent.getisInitialState()) {
					publisher_.postEvent(event);
					event.changesArePosted();
				} else {
					event.nextState();
					publisher_.postEvent(event);
					event.changesArePosted();
				}
				//System.out.println("scheduled event:"+event.toString());
			} catch(InterruptedException e) {
				return;
			}
		}
	}
}
